type t('a) = {data: 'a};

let decode = (decoder, json) =>
  switch Json.Decode.{data: json |> field("data", decoder)} {
  | {data} => Vow.Result.return(data)
  | exception (Json.Decode.DecodeError(_)) =>
    json
    |> BsLibrarian.ErrorModel.unwrapDecodeExternal
    |> BsLibrarian.ErrorModel.parseExternalError
    |> Vow.Result.fail
  };