external toFetchBlob : BsBlob.Blob.t => Fetch.blob = "%identity";

let wrapBs = cb => [@bs] (a => cb(a));

let nullableFieldEncoder = encoding =>
  encoding
  |> List.fold_left(
       (memo, item) =>
         switch item {
         | Some(item) => memo @ [item]
         | None => memo
         },
       []
     )
  |> Json.Encode.object_;